import sys

#This file takes in a list of 16-bit octal values (6 digits)
#and outputs a list of 64-bit wide hex values (Xilinx' format for initializing
#a 64 bit wide ram using the "readmemh" command in Verilog)

#Run this program with command line options: [filename] [depth in 64-bit words]
file = sys.argv[1]
depth = int(sys.argv[2])
infile = open(file,"r")
oct_code = infile.readlines()

hex_code = []
outfile = open("cray_rom.txt","w")

#loop through the octal machine code, and convert it to integers
for line in oct_code:
    line = line.strip()
    if line.isdigit():
        hex_code.append(int('0' + line,8))     #strip the code to ignore any comments

#now print out the array of hex code in groups of four
for i in range(0,len(hex_code),4):
    if (i+3)<=(len(hex_code)-1):
        outfile.write("%04x" % hex_code[i+3] + "%04x" % hex_code[i+2] + "%04x" % hex_code[i+1] + "%04x" % hex_code[i] + "\n")
    elif (i+2)<=(len(hex_code)-1):
        outfile.write("0000" + "%04x" % hex_code[i+2] + "%04x" % hex_code[i+1] + "%04x" % hex_code[i] + "\n")
    elif (i+1)<=(len(hex_code)-1):
        outfile.write("00000000" + "%04x" % hex_code[i+1] + "%04x" % hex_code[i] + "\n")
    else:
        outfile.write("000000000000" + "%04x" % hex_code[i] + "\n")


for i in range(0,depth-(len(hex_code)/4)-2):
    outfile.write("0000000000000000\n")
outfile.write("0000000000000000")

infile.close()
print "File written successfully"
outfile.close()
